# fcos.py
# Vojtěch Golda
from torchvision.models.detection import fcos_resnet50_fpn, FCOS_ResNet50_FPN_Weights
from util.model_util import preprocess, get_data_bb, get_model, batch2boxes

from models.model_util import ModelUtil

# 26, 14, 40
# 36


class FCOS(ModelUtil):
    def __init__(self, device, filename="models/fcos.pth"):
        self.device = device
        self.model = fcos_resnet50_fpn
        self.weights = FCOS_ResNet50_FPN_Weights
        self.target_size = (400, 400)
        self.filename = filename

    def preprocess(*args, **kwargs):
        return preprocess(*args, **kwargs)

    def get_data(*args, **kwargs):
        return get_data_bb(*args, **kwargs)

    def get_model(*args, **kwargs):
        return get_model(*args, **kwargs)

    def batch2boxes(*args, **kwargs):
        return batch2boxes(*args, **kwargs)

